#include <stdio.h>
#include <sys/types.h>

#include "modules.h"
#include "sha1sum.h"

/**
 * @brief
 *	PID ̿ μ̸ μ ؽð .
 * @param pid μ ID
 * @param pname μ ̸  char 迭 
 * @param ctx    Context 
 * @remark
 *	proc  ýۿ Ͽ μ ̸ ش μ ؽð Ѵ.
 * @return
 *	ϸ 0, ϸ -1.
 */
int getPnameSha1(pid_t pid, char *pname, SHA1_CONTEXT *ctx)
{
	FILE *fp =NULL;
	char buffer[100];
	char *token;
	
	/* open  "/proc/pid/status"  */
	sprintf(buffer, "/proc/%d/status", pid);
	fp = fopen(buffer, "rb");
	if(fp == NULL) {
		printf("%s(%d): Can't open %s\n", __FUNCTION__, __LINE__, buffer);
		return -1;
	}
	
	fgets(buffer, 100, fp);
	
	/* get process name */
	token = strtok(buffer, "\t");
	token = strtok(NULL, "\n");
	sprintf(pname, "%s", token);
	
	fclose(fp);
	
	
	/* get sha1 */
	sprintf(buffer, "/proc/%d/exe", pid);
	if(sha1sum(buffer, ctx) == -1) {
		return -1;
	}
	
	return 0;
}
