/**
 * @file proc_list.c
 * @brief μ pid 迭  ׿ شϴ sha1sum  Ϸ ϴ Լ 
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "modules.h"
#include "sha1sum.h"
#include "proc_list.h"

extern int Debug;

/**
 * @brief   μ pid  迭 · Ѵ.
 * @remark   μ pid  迭 · Ѵ. /proc 丮 Ʒ 丮  ϳ  
 *  ù ° ڰ ڶ ش 丮  μ 丮 Ѵ.
 * μ 丮 ϳ ߰ߵ   realloc() Ͽ  迭 ũ⸦ ϳ ÷.
 * 迭 ũ⸦    ٸ ε ũ⸦  ʱ  迭  -1 ־.
 * @return ϸ μ pid 迭 ּ, ϸ NULL.
 */
pid_t *get_curr_pid_list(void)
{
	pid_t *curr_pid_list = NULL;	// pid Ʈ 迭.
	int proc_cnt = 0;	// μ 
	DIR *dp;
	struct dirent *entry;
	struct stat statbuf;
	
	if((dp = opendir(PROC_DIR)) == NULL) {
		fprintf(stderr, "cannot open directory: %s\n", PROC_DIR);
		return NULL;
	}	
	
	while((entry = readdir(dp)) != NULL) {
		lstat(entry->d_name, &statbuf);
		if(S_ISDIR(statbuf.st_mode)) {
			if(strcmp(".", entry->d_name) == 0 ||
					strcmp("..", entry->d_name) == 0 || 
					(entry->d_name[0] < '0' || entry->d_name[0] > '9')) {
				continue;
			}

			proc_cnt++;
			
			curr_pid_list = (pid_t *)realloc(curr_pid_list, sizeof(pid_t) * proc_cnt);
			if(curr_pid_list == NULL) {
				printf("memory allocation failed.\n");
				return NULL;
			}
			
			if(Debug > 3) {
				printf("%s(%d): entry->d_name = %s\n", __FUNCTION__, __LINE__, entry->d_name);
			}
			curr_pid_list[proc_cnt-1] = atoi(entry->d_name);	// μ ID  ȯϿ .			
		}
	}	
	proc_cnt++;
	curr_pid_list = (pid_t *)realloc(curr_pid_list, sizeof(pid_t) * proc_cnt);
	
	curr_pid_list[proc_cnt-1] = -1;	// 迭  ǥϱ  -1 ִ´.

	if(Debug > 1) {
		printf("%s(%d): proc_cnt = %d\n", __FUNCTION__, __LINE__, proc_cnt);
	}
	
	return curr_pid_list;
}

/**
 * @brief pid 迭  Ҵ ޸  freeϴ ũ.
 * @param x pid 迭  ּ.
 * @remark pid 迭  ּҸ   ش ּҸ freeϰ NULL ʱȭѴ.
 */
#define free_curr_pid_list(x) \
	if((x) != NULL) {	\
		free((x));	\
	}	\
	(x) = NULL;	

/**
 * @brief   μ sha1sum  Ϸ Ѵ.
 * @param curr_proc_lst   μ Ʈ  迭.
 * @param write_flag μ о Ϸ  쿡 1,   쿡 0
 * @remark   μ sha1sum  Ϸ Ѵ.
 *  δ CURR_PROC_LIST̸ ׻ overwriteȴ. Ǵ  Text̰ 
 * "μ<>sha1sum"̴.
 * @return ϸ μ , ϸ -1
 */
int write_curr_proc_list(struct proc_list_t *curr_proc_lst, int write_flag)
{
	SHA1_CONTEXT ctx;
	char name[256];
	FILE *fp_cur_proc_lst;
	pid_t *curr_pid_list = NULL, *curr_pid_list_head; 
	int i;
	int curr_proc_num = -1;
	if(write_flag ==1) {
		fp_cur_proc_lst = fopen(CURR_PROC_LIST, "w");
		if(fp_cur_proc_lst == NULL) {
			fprintf(stderr, "%s(%d): can't open file: %s\n", __FUNCTION__, __LINE__, CURR_PROC_LIST);
			return -1;
		}	
	}
	
	curr_pid_list = get_curr_pid_list();	// pid 迭  ּҸ ´.
	curr_pid_list_head = curr_pid_list;	// pid 迭 free   ּҸ ޾Ƶд.
	
	while(curr_pid_list != NULL && *curr_pid_list != -1) {
		if(Debug > 3) {
			printf("%s(%d): curr_pid_list = %d\n", __FUNCTION__, __LINE__, *curr_pid_list);
		}
		
		if(getPnameSha1(*curr_pid_list, name, &ctx) == -1) {	// -1 ϵǾٰ ؼ Լ ؼ  ȴ.
			curr_pid_list++;
			continue;
		}
		
		curr_proc_num++;
		
		if(write_flag == 1) {
			fprintf(fp_cur_proc_lst, "%s\t", name);		
			for(i = 0; i < 20; i++) {
		    	fprintf(fp_cur_proc_lst, "%02x", ctx.buf[i]);
			}
			fprintf(fp_cur_proc_lst, "\n");
		}
		
		strcpy(curr_proc_lst[curr_proc_num].proc_name, name);
		curr_proc_lst[curr_proc_num].pid = *curr_pid_list;
		curr_proc_lst[curr_proc_num].white_proc = 0;
		sprintf(curr_proc_lst[curr_proc_num].sha1sum_value,
				"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x", 
				ctx.buf[0], ctx.buf[1], ctx.buf[2], ctx.buf[3], ctx.buf[4], ctx.buf[5], ctx.buf[6], ctx.buf[7], ctx.buf[8], ctx.buf[9],
				ctx.buf[10], ctx.buf[11], ctx.buf[12], ctx.buf[13], ctx.buf[14], ctx.buf[15], ctx.buf[16], ctx.buf[17], ctx.buf[18], ctx.buf[19]);

		curr_pid_list++;
	}
	
	free_curr_pid_list(curr_pid_list_head);	// ޾Ƶ pid 迭 ּҸ freeѴ.

	if(write_flag == 1) {
		fclose(fp_cur_proc_lst);
	}
	
	return curr_proc_num;
}

/**
 * @brief ڷ Ѱܹ μ Ʈ Ϸ Ѵ.
 * @param file_name  ϸ
 * @param proc_lst  μ Ʈ
 * @param proc_num  μ 
 * @remark file_name Ѱܹ ϸ proc_lst μ Ʈ Ϸ Ѵ.
 * @return ϸ 0, ϸ -1
 */
int write_proc_list(char *file_name, struct proc_list_t *proc_lst, int proc_num)
{
	int i;
	FILE *fp_proc_lst;

	fp_proc_lst = fopen(file_name, "w");
	if(fp_proc_lst == NULL) {
		fprintf(stderr, "%s(%d): can't open file: %s\n", __FUNCTION__, __LINE__, file_name);
		return -1;
	}		
	
	for(i = 0; i < proc_num; i++) {
		fprintf(fp_proc_lst, "%s\t%s\n", proc_lst[i].proc_name, proc_lst[i].sha1sum_value);
	}
	
	fclose(fp_proc_lst);
	
	return 0;
}

